#include"mapCache.h"

MapCache::MapCache(int size = 12) {
	QImage tempImg;

	_nextId = 0;
	_cacheSize = size;
	for (int i = 0; i < size; i++) {
		_maps.push_back(tempImg);
		_mapFileNames.push_back("");
	}
}

QImage * MapCache::getMap(QString mapFileName) {
	for (int i = 0; i < _cacheSize; ++i)
		if (_mapFileNames[i] == mapFileName) {
			return &_maps[i];
		}
	
	_mapFileNames[_nextId] = mapFileName;
	if(_maps[_nextId].load(mapFileName)) {
		int rtnId = _nextId;
		if (++_nextId >= _cacheSize) {
			_nextId = 0;
		}
		return &_maps[rtnId];
	} else {
		_mapFileNames[_nextId] = "";
		return NULL;
	}
}
